/*
Schulungsboard SB8v2006 Allround-Testprogramm ((c) www.humerboard.at) 

Autoren:		Weingerl Patrick	/ Stoier Markus
Hhere Technische Bundeslehr- und Versuchsanstalt BULME Graz Gsting
Datum:			10.September 2005
----------------------------------------------------------------------
Aufgabenstellung:	
	Die Grund StateMachine, steuerbar durch den Drehimpulsgeber 
	(nachfolgend DIMP), bietet eine Menauswahl fr die
	implementierten Programme ( Mens 1 bis 7 ).
!!!!UM IN DIE MENAUSWAHL ZU GELANGEN, MUSS JUMPER 1 GESETZT SEIN!!!!!
----------------------------------------------------------------------
Implementierte Funktionen:
1	ADPoti();			Beide Werte der POTIs werden am LCD ausgegeben
2	drehimpgeber();		LCD: 0, je nach Richtung: Zahl ++; oder --;
3	LEDTest();			LEDMatrix, Binrzhler (LEDBalken + 7Segment)
4	lichtmessung();		Lichtintensittsmessung	(Ausgabe am LCD)
5	read_ab();			DIMP wird eingelesen
6	rtc();				RealTimeClock am LCD (Eingabe durch Tastatur)
7	tempmessung();		Temparaturmessung durch NTC (ADC Test)

Weiters wurde eine goback(); Funktion implementiert, was bedeutet, 
dass man durch Kurzes umschalten des SW1 JUMPER 1 wieder in die 
Menauswahl zurckkehren kann.
WICHTIG: 	Nicht vergessen, den Jumper danach wieder zu setzen, um 
			ein neues Programm ausfhren zu knnen.


Optimierung der Kommentare fr 1280x800 Widescreen

*/
#include<reg517a.h>
#include<lcd.h>
#include<stdio.h>
#include<math.h>


//constante definitions


#define WT 2 
#define monitor 0xE000 							//Festgelegte Werte (bentigen keinen Codespeicher am C)

//variable datatype definition


idata char i,j,e,count,swmenu;
sbit Dra = P1^4;								//DIMP A auf Port 1.4
sbit Drb = P1^0;  								//DIMP B auf Port 1.0
sbit gdin =  P1^5;
sbit load =  P1^6;								//Lade-Bit fr Grafische LEDMatrix
sbit gclk =  P3^5;								//Clock fr Grafische LEDMatrix


bit flag2;

char serg,hh,mm,ss,merg,herg;					//start rtc datatypes
sbit SCL = P3^5;
sbit SDA = P3^4;
idata int x;									//end rtc datatypes

bit secflag;									//start lightmessure datatypes
unsigned int messung_old,messung;
char uebold,ueb;
float frequenz;									//end lightmessure datatypes


idata char old_dimp,dimp,dimpb,*zeiger,richtung;
idata int  test,taste,wert;

int adu;										//tempmessung
char buf[21];									//Buffer fr die Ausgabe am LCD

bit flag;

idata unsigned char menu,state;					//idata um den unsigned char an reservierten Codespeicherplatz auszulagern
idata char samplejmp,ownjmp;


//code tables subroutines


idata char graphdata2[]={0x08,0x14,0x22,0x14,0x14,0x22,0x14,0x08};			//Grafikmasken fr bestimmte Symbole (LEDMATRIX)
idata char mask[8]={0x80,0x40,0x20,0x10,0x08,0x04,0x02,0x01};
idata char text[10]={0xC0,0xF9,0xA4,0xB0,0x99,0x92,0x83,0xF8,0x80,0x98};


//common prototypes


int aduwert(char kanal);				  		//Analog-Digital-Converter(ADC) einlesen (Kanal 9 fr NTC)
char read_ab(void);								//Drehimpulsgeber auslesen (Richtung wird zurckgegeben)
void samples(void);								
void AS1100send(char addr, char daten);			//Subroutine zum Senden(konfigurieren) der LEDMatrix

//sample program prototypes


void drehimpgeber(void);
void ADPoti(void);
void LEDtest(void);
void tempmessung(void);
void tastendec(void);
void rtc(void);
void lichtmessung(void);
//void i2ctemp(void);
void goback(void);


//menu prototypes


void menu1(void);
void menu2(void);
void menu3(void);
void menu4(void);
void menu5(void);
void menu6(void);
void menu7(void);
void menu8(void);


//code tables state machine


code (*fpnt[2] [7])()=							//*fpnt (FUNCTIONPOINT) fr die StateMachine[Zeilen] [Spalten]
{
{menu7,menu1,menu2,menu3,menu4,menu5,menu6},	//Funktionsnamen werden eingetragen
{menu2,menu3,menu4,menu5,menu6,menu7,menu1}
};


code unsigned char nextstate_tab [2] [7]=		//auch der nchste State muss ermittelt werden
{
{6,0,1,2,3,4,5},  								//Erstellen einer Statemachine siehe Programmiermodule www.humerboard.at 
{1,2,3,4,5,6,0}
};


//main program

void main()
{
init_lcd();										//LCD initialisieren
blank_lcd();
print_lcd(1,1,"Humerboard SB8v2006");
print_lcd(2,1,"Version 1.0");
ownjmp=(P7>>7) && 0x01;
warte(5000);
if(ownjmp==0)  									//Bereits vorbereitet fr nchste Humerboard Version  
	{P4=0x55;									//Diese Beispielprogramme werden in ein Flash gebrannt, und knnen
/*	#pragma asm									//in zuknftigen Versionen direkt auf jedem Humerboard durch setzen von
			LJMP monitor					 	//SW1 JUMPER 1 gestartet werden (JUMPER 2 startet dann das letzte vom 
	#pragma endasm	*/							//Benutzer selbst erstellte Programm)
	}
samplejmp=(P7>>6) && 0x01;
if(samplejmp==0)
	{samples();}
/*
#pragma asm
		LJMP monitor
#pragma endasm	*/
}


//samples main selection


void samples(void)
{
state=0;
init_lcd();
blank_lcd();
EAL=1;	  										//Interruptfreigabe fr DIMP-PUSHBUTTON
EX6=1;
menu1();										//Start durch Men 1
while(1)
{
test=1;										    //Setzen der Variable, die durch Auswahl des Mens(DIMP PUSH)
read_ab();										//wieder rckgesetzt wird; berprfung am Programmende

if(richtung!=0)
	{
	switch(richtung)							
		{
			case  1:	richtung=1;	break;
			case -1:	richtung=0; break;
		}
	(*fpnt [richtung] [state])();				//Variable richtung fliet in die zeile der fpnt Tabelle ein,
												//state selektiert die spalte
	state=nextstate_tab[richtung][state];		//Das Selbe passiert bei d. Berechnung des neuen State; in der nextstate_tab
	}

if(test==0)										//wenn DIMP-PUSHBUTTON gedrckt wurde, wird berprft welches men gewhlt
	{											//wurde; das entsprechende Unterprogramm wird aufgerufen
	EAL=0;
	EX6=0;
	switch(swmenu)
		{
		case 1:	drehimpgeber();	break;
		case 2:	ADPoti();		break;
		case 3:	LEDtest();		break;
		case 4:	tempmessung();	break;
		case 5:	tastendec();	break;
		case 6:	rtc();			break;
		case 7:	lichtmessung();	break;
//		case 8: i2ctemp();		break;
		}	
	}
}
}


//subroutines


int aduwert(char kanal)
{
ADCON1=kanal;
ADDATL = 0;
while(BSY);
return((ADDATL>>6)+ADDATH*4);
}


void send(int wertx) 
{
	for(i=15;i>=0;i--)
		{
		gdin = (wertx >> i) & 0x0001;
		gclk=1;gclk=0;
		} 
	load=1;load=0;
}


void AS1100send(char addr, char daten) 
{
unsigned char mask;				// Maske zum extrahieren eines Bits
								// Muss unsigned sein, sonst wird kein logischer shift gemacht

mask = 0x80;					// Maske beginnt mit 10000000
while(mask) 					// Adressbyte schicken MSB zuerst
	{
	gdin = (addr & mask); 		// Bit extrahieren und Ausgang setzten
	gclk = 1;					// positive Taktflanke erzeugen
	gclk = 0;					// negative Taktflanke erzeugen				
	mask = mask >> 1;			// Maske: bit um 1 Stelle nach rechts schieben 
	}
mask = 0x80;					// Maske beginnt mit 10000000
while(mask) 					// Datenbyte schicken MSB zuerst
	{
	gdin = (daten & mask); 		// Bit extrahieren und Ausgang setzten
	gclk = 1;					// positive Taktflanke erzeugen
	gclk = 0;					// negative Taktflanke erzeugen					
	mask = mask >> 1;			// Maske: bit um 1 Stelle nach rechts schieben
	}
load = 1;						// Ladeimpuse erzeugen
load = 0;

}

// AS1100 Initialisieren
void graphledinit(void)
{
load = 1;						// Ladeimpuse erzeugen um Schieberegister auf Anfang zu setzen
load = 0;


AS1100send(0x0E,0x02);			// Reset senden
AS1100send(0x0E,0x00);			// Reset verlassen
AS1100send(0x0C,0x01);			// Shutdown mode verlassen
AS1100send(0x0B,0x07);			// Scan limit setzen
AS1100send(0x09,0x00);			// Keine BCD-Dekodiereung
AS1100send(0x0A,0x0F);			// Intensity max
AS1100send(0x0F,0x00);			// Display test OFF
}


void Zeichen(void)	
{
	   	zeiger = &graphdata2[0];
		for(j=1;j<=8;j++)											//	gleichbedeutend mit: [0x0100=256]
		{															//	wert = 0x0100 + *zeiger; send(wert); zeiger++;
			wert= (int)(256*j) + *zeiger; send(wert); zeiger++;		//	wert = 0x0200 + *zeiger; send(wert); zeiger++;
		}															//	wert = 0x0300 + *zeiger; send(wert); zeiger++; .....
}


void wait (int msec)
{
char i;
for (msec; msec!=0; msec--)
for (i=0; i<83; i++);
}


unsigned char i2c_rec()
{
unsigned char i;
unsigned char mask = 0x80; 
unsigned char zeich = 0;
for (i=0;i<8;i++)
{SCL = 1;
wait(WT);
zeich = (int)SDA ? (mask | zeich) : zeich;
mask >>= 1;
SCL = 0;
wait(WT);
}
return(zeich);
}


void i2c_trans(unsigned char zeich)
{
unsigned char i;
unsigned char mask = 0x80; 
printf(" ->Transmit: ");
for (i=0;i<8;i++)
{
SDA = ((zeich & mask) == mask) ? 1:0;
printf("%1d|",(int)SDA);
mask >>= 1;
wait(WT);
SCL = 1;
wait(WT); 
SCL = 0;
}
SDA = 1;
SCL = 1;
if (SDA==0) printf(" Acknowledge received\n");
if (SDA==1) printf(" Acknowledge not received\n");
wait(WT);
SCL = 0;
wait(WT);
}




void i2c_start()
{
SCL = 1;
SDA = 0; 		// Serial Data Line IC Bus 
wait(WT); 		// Wait min. 4,7 sec - see IC timing protocol PCF8583
SCL = 0; 		// Serial Clock Line IC Bus
wait(WT);
}


void i2c_stop()
{
SDA = 0; 		//Serial Data Line IC Bus 
wait(WT);
SCL = 1; 		//Serial Clock Line IC Bus 
wait(WT);
SDA = 1;
wait(WT);
}


void uhrset(char uhrzeitst,char uhrzeitmin,char uhrzeitsec)
{
i2c_start(); 			//Startbedingung
i2c_trans(0xA2); 		//Sendet d. Slaveadresse mit R/W=>schreiben
i2c_trans(0x02); 		//Sendet das 2. Adressbyte fr den Sekundenregister
i2c_trans(uhrzeitsec); 	//Sendet den Wert fr d. Sekundenregister(30)
i2c_stop(); 			//Stopbedingung
i2c_start();
i2c_trans(0xA2);
i2c_trans(0x03); 		//Sendet das 2. Adressbyte fr den Minutenregister
i2c_trans(uhrzeitmin); 
i2c_stop();
i2c_start();
i2c_trans(0xA2);
i2c_trans(0x04); 		//Sendet das 2. Adressbyte fr den Stundenregister
i2c_trans(uhrzeitst); 	//Sendet den Wert fr den Stundenregister
i2c_stop();
}




//menu parts [states]


void menu1(void)
{
print_lcd(1,1,"Menu 1");
print_lcd(2,1,"Drehimpulsgeber     ");
swmenu = 1;
}


void menu2(void)
{
print_lcd(1,1,"Menu 2");
print_lcd(2,1,"AD Wandler Pot.     ");
swmenu = 2;
}


void menu3(void)
{
print_lcd(1,1,"Menu 3");
print_lcd(2,1,"Binaerz. u. GraphLED");
swmenu = 3;
}


void menu4(void)
{
print_lcd(1,1,"Menu 4");
print_lcd(2,1,"Temp. Messung       ");
swmenu = 4;
}


void menu5(void)
{
print_lcd(1,1,"Menu 5");
print_lcd(2,1,"Tastaturdekoder     ");
swmenu = 5;
}


void menu6(void)
{
print_lcd(1,1,"Menu 6");
print_lcd(2,1,"RealTimeClock       ");
swmenu = 6;
}


void menu7(void)
{
print_lcd(1,1,"Menu 7");
print_lcd(2,1,"Lichtmengenmessung  ");
swmenu = 7;
}


void menu8(void)
{
print_lcd(1,1,"Menu 8");
print_lcd(2,1,"I2C Tempmessung     ");
swmenu = 8;
}

//sample programs


void LEDtest(void)
{
char run;
load=0;gclk=0;
graphledinit();
Zeichen();
init_lcd();
blank_lcd();
print_lcd(1,7,"Led-Test");
print_lcd(2,3,"Humerboard V1.0");
P4=0;
while(1)
{
		e++;if(e==10)e=0;
		warte(500);
		P6=0xBF;
		P4=count++;
		P6=0x7F;
		P4=text[e];
		run=0;
		while(run<=12)
		{
		gclk=1;
		gclk=0;
		run++;
		}
goback();
}
}


void ADPoti(void)
{
	init_lcd();
	blank_lcd();
	print_lcd(1,4,"ADWandler Pot.");
	while(1)
{
while(BSY);
sprintf(buf,"P1= %4d  P2= %4d",(int)aduwert(10),(int)aduwert(9));
print_lcd(2,2,buf);
goback();
}
}


void tempmessung(void)
{
code float aa=0.0012814814, bb=0.000236678791, cc=0.0000000908736406, r_ref = 4990;
float r_temp,lnr,temp;
init_lcd();
blank_lcd();
print_lcd(1,2,"Temperaturmessung");
spezial_graf();
char_lcd(2,14,7);
while(1)
{
	adu = aduwert(8);
	r_temp = r_ref*adu/(1023-adu);
	lnr = log(r_temp);
	temp = (1.0/(aa+bb*lnr+cc*lnr*lnr*lnr));
	temp-=273.2;
	sprintf(buf,"T=%6.2f",temp);
	print_lcd(2,5,buf);
goback();
}
}


void tastendec(void)
{	IT0=1;		//Neg. Flanke Ext. Int. 0 
	EAL=1;		//Generelle Freigabe Int. 0	
	EX0=1;		//Freigabe Ext. Int. 0
	init_lcd();
	blank_lcd();
 	print_lcd(1,3,"Tastaturdecoder");
	print_lcd(2,3,"Taste:");
	while(1)	//Endlosschleife
	{
		if(flag) 
		{
			flag=0;
			sprintf(buf,"%x",taste);
			print_lcd(2,10,buf);
		}
	goback();
	}
}


	void rtc(void)
	{init_lcd(); 	//LCD-Display initialisieren u. lschen
	blank_lcd();
	EAL=1; 			//Interrupt 2 freigeben
	IT1=1;
	IT0=1;
	EX1=1;
	EX0=1;	
	flag2 = 0;
	print_lcd(1,1,"Tastatureingabe:");
	print_lcd(2,1,"Vordere Stundenzif.");
	while(flag2 == 0);
	hh = hh + taste*0x10;
	for (x=0;x>=10000;x++);
	flag2 = 0;	
	print_lcd(2,1,"Hintere Stundenzif.");
	while(!flag2);
	hh = hh + taste;
	for (x=0;x>=10000;x++);
	flag2 = 0;
	print_lcd(2,1,"Vordere Minutenzif.");
	while(!flag2);
	mm = mm + taste*0x10;
	for (x=0;x>=10000;x++);
	flag2 = 0;
	print_lcd(2,1,"Hintere Minutenzif.");
	while(!flag2);
	mm = mm + taste;
	for (x=0;x>=10000;x++);
	flag2 = 0;
	print_lcd(2,1,"Hintere Secundenzif.");
	while(!flag2);
	ss = ss + taste*0x10;
	for (x=0;x>=10000;x++);
	flag2 = 0;
	print_lcd(2,1,"Hintere Secundenzif.");
	while(!flag2);
	ss = ss + taste;
	for (x=0;x>=10000;x++);
	flag2 = 0;
	blank_lcd();
	print_lcd(1,1,"Uhr laeuft");
	uhrset(hh,mm,ss);
	
	while(1)
	{if (flag==1)
	{i2c_start(); 			//Startbedingung 
	i2c_trans(0xA2); 
	i2c_trans(0x02); 		//Sendet das 2. Adressbyte mit der Adresse fr den Sekundenregister 
	i2c_start(); 			//Repeated start condition
	i2c_trans(0xA3); 		//Sendet wieder die Slaveadresse aber mit R/W=1 => lesen 
	serg=i2c_rec(); 		//Empfngt den Wert den der PCF8583 auf den IC-Bus geschickt hat (vom Sekundenregister) 
	i2c_stop(); 			//Stopbedingung 
	i2c_start(); 			//Startbedingung 
	i2c_trans(0xA2); 		//Slaveadresse 
	i2c_trans(0x03); 		//Adresse fr den Minutenregister 
	i2c_start();
	i2c_trans(0xA3); 		//Slaveadresse mit R/W=1
	merg=i2c_rec(); 		//Empfngt den Wert des Minutenregister
	i2c_stop(); 			//Stopbedingung 
	if (serg<=35)
	{
	i2c_start();
	i2c_trans(0xA2);
	i2c_trans(0x04); 		//Adresse fr den Stundenregister 
	i2c_start();
	i2c_trans(0xA3); 		//Slaveadresse mit R/W=1 
	herg=i2c_rec(); 		//Empfngt den Wert des Stundenregister
	i2c_stop();
	}
	sprintf(buf, "Uhrzeit:%2x:%2x:%2x",(int)herg,(int)merg,(int)serg);
	print_lcd(2,1,buf); 	//Ausgabe am LCD-Display
	flag=0;
	}
	goback();
	}
	}

void goback(void)
{
samplejmp=(P7>>7) && 0x01;
if(samplejmp==1)
	{
	samples();
	}
}


void lichtmessung(void)
{
EX1=1;
IT1=1;
ET2=1;
T2CON=0x02; 
ueb=0;
uebold=0;
TF2=0;
IP0=4;
init_lcd();
blank_lcd();
EAL=1;
print_lcd(1,1,"Lichtstaerkenmessung");
while(1)
{
if(secflag==1)
{
frequenz=((float)messung-(float)messung_old)+uebold*65536.0;
sprintf(buf,"%7.3fuW",frequenz*.375/250);
print_lcd(2,1,buf);
sprintf(buf,"%5d lx",(int)(frequenz*.375*6.8/250));
print_lcd(2,13,buf);
secflag=0;
messung_old=messung;
}
goback();
}
}

	

void i2ctemp(void)
{

}



void drehimpgeber(void)
{

	EAL=1;
	EX6=1;
	init_lcd();
	blank_lcd();
	print_lcd(1,3,"Drehimpulsgeber");
	while(1)
	{
	test=test + read_ab();
	sprintf(buf,"%5d",test);
	print_lcd(2,10,buf);
	goback();
	}
}


char read_ab(void)
{
richtung=0;
dimp=Dra;
dimpb=Drb;
dimp=dimp<<1;
dimp=dimp+dimpb;
if(old_dimp==0 & dimp==1 ) 			richtung=1;
if(old_dimp==1 & dimp==3 ) 			richtung=1;
if(old_dimp==3 & dimp==2 ) 			richtung=1;
if(old_dimp==2 & dimp==0 ) 			richtung=1;
if(old_dimp==0 & dimp==2 ) 			richtung=-1;
if(old_dimp==2 & dimp==3 ) 			richtung=-1;
if(old_dimp==3 & dimp==1 ) 			richtung=-1;
if(old_dimp==1 & dimp==0 ) 			richtung=-1;
old_dimp=dimp;
return(richtung);//Rckgabe des Drehimpulsgebers
}


//interrupt service routines


void druck (void) interrupt 13
{test=0;}


void press_button (void) interrupt 0
{flag=1;flag2=1; taste=P7&15;}
   

void secticker(void) interrupt 2
{
messung=T2;
uebold=ueb; 
ueb=0; 
secflag=1;
flag=1;
}


void t2int(void) interrupt 5
{
TF2=0; 
ueb++; 
}
